/**
 * @file err_codes.h
 * @author Copyright (c) 2016 ESET, spol. s r.o.
 */

#define APIERROR_BASE 2000

// common error codes

#define ERAERROR_SUCCESS						NO_ERROR // 0
#define ERAERROR_UNKNOWN						APIERROR_BASE + 1

// ERA API error codes

#define CMDERROR_SOME_ERRORS_IGNORED		7

#define APIERROR_CONNECTION_ERROR					APIERROR_BASE + 2
#define APIERROR_INVALID_PARAMETER					APIERROR_BASE + 3
#define APIERROR_INVALID_STATUS_FROM_SERVER			APIERROR_BASE + 4
#define APIERROR_WINSOCK_INITIALIZATION_FAILED		APIERROR_BASE + 5
#define APIERROR_CONNECTION_FAILED					APIERROR_BASE + 6
#define APIERROR_AUTHORIZATION_FAILED				APIERROR_BASE + 7
#define APIERROR_TABLE_NOT_FOUND					APIERROR_BASE + 8
#define APIERROR_QUERY_INITIALIZATION_FAILED		APIERROR_BASE + 9
#define APIERROR_QUERY_DOES_NOT_EXIST				APIERROR_BASE + 10
#define APIERROR_FIELD_GETTING_FAILED				APIERROR_BASE + 11
#define APIERROR_COLUMN_NOT_FOUND					APIERROR_BASE + 12
#define APIERROR_INVALID_VALUE_IN_CONDITION			APIERROR_BASE + 13
#define APIERROR_INSUFFICIENT_BUFFER				APIERROR_BASE + 14
#define APIERROR_INVALID_STATUS						APIERROR_BASE + 15


// *-> SECTION 1 500+
#define APIERROR_FILE_DOESNT_EXIST					APIERROR_BASE + 500
#define APIERROR_CANNOT_OPEN_FILE					APIERROR_BASE + 501
#define APIERROR_CANNOT_CREATE_FILE					APIERROR_BASE + 502
#define APIERROR_CANNOT_READ_FILE					APIERROR_BASE + 503
#define APIERROR_CANNOT_WRITE_FILE					APIERROR_BASE + 504
#define APIERROR_FILE_IS_TOO_LARGE					APIERROR_BASE + 505
#define APIERROR_NOT_ENOUGH_MEMORY					APIERROR_BASE + 506
#define APIERROR_EXPIRED_LICKEY						APIERROR_BASE + 507
#define APIERROR_SERVER_CANNOT_CREATE_LICKEY		APIERROR_BASE + 508
#define APIERROR_SERVER_CANNOT_WRITE_LICKEY			APIERROR_BASE + 509
#define APIERROR_SERVER_CANNOT_UPDATE_LICKEY		APIERROR_BASE + 510
#define APIERROR_SERVER_CANNOT_RELOAD_LICENSE		APIERROR_BASE + 511
#define APIERROR_CANNOT_OPEN_CONFIG_FILE			APIERROR_BASE + 512
#define APIERROR_CANNOT_CREATE_CONFIG_FILE			APIERROR_BASE + 513
#define APIERROR_CANNOT_GET_SERVER_CONFIG			APIERROR_BASE + 514
#define APIERROR_CANNOT_OPEN_SERVER_CONFIG			APIERROR_BASE + 515
#define APIERROR_CANNOT_WRITE_CONFIG				APIERROR_BASE + 516
#define APIERROR_UPLOAD_SERVER_CONFIG				APIERROR_BASE + 517
#define APIERROR_CANNOT_COPY_CONFIG_FILE			APIERROR_BASE + 518
#define APIERROR_CANNOT_GET_LOCAL_ERA_DIR			APIERROR_BASE + 519
#define APIERROR_UNKNOWN_CFG_SETTING				APIERROR_BASE + 520
#define APIERROR_INVALID_CFG_SETTING_VALUE			APIERROR_BASE + 521
#define APIERROR_CANNOT_OPEN_REMOTE_DATA			APIERROR_BASE + 522
#define APIERROR_CANNOT_READ_REMOTE_DATA			APIERROR_BASE + 523
#define APIERROR_CANNOT_OPEN_XML_DATA				APIERROR_BASE + 524
#define APIERROR_CANNOT_READ_XML_DATA				APIERROR_BASE + 525
#define APIERROR_CANNOT_WRITE_XML_DATA				APIERROR_BASE + 526
#define APIERROR_NO_MORE_DATA						APIERROR_BASE + 527
#define APIERROR_NOTIFICATION_TABLE_CORRUPTED		APIERROR_BASE + 528
#define APIERROR_LOGFORWARD_UPDATE_FAILED			APIERROR_BASE + 529
#define APIERROR_LOGLEVEL_NOT_SUPPORTED				APIERROR_BASE + 530
#define APIERROR_CANNOT_OPEN_POLICY_RULES			APIERROR_BASE + 531
#define APIERROR_SERVER_RUNS_IN_APPLICATION_MODE	APIERROR_BASE + 532
#define APIERROR_INVALID_NUMERIC_VALUE				APIERROR_BASE + 533
// <-* SECTION 1



// *-> SECTION 2 1000+
#define APIERROR_REPORT_QUERY_INITIALIZATION_FAILED	APIERROR_BASE + 1000
#define APIERROR_REPORT_QUERY_DOES_NOT_EXIST		APIERROR_BASE + 1001
#define APIERROR_POLICY_QUERY_DOES_NOT_EXIST		APIERROR_BASE + 1002
#define APIERROR_POLICY_CREATE_UPLOAD_XML			APIERROR_BASE + 1003
#define APIERROR_POLICY_CREATE_NAME_NOT_UNIQUE		APIERROR_BASE + 1004
#define APIERROR_POLICY_INVALID_PARENT				APIERROR_BASE + 1005
#define APIERROR_POLICY_INVALID_POLICY				APIERROR_BASE + 1006
#define APIERROR_POLICY_UPDATE_UPLOAD_XML			APIERROR_BASE + 1007
#define APIERROR_POLICY_CANNOT_UPDATE				APIERROR_BASE + 1008
#define APIERROR_CANNOT_UPDATE_DEFAULT_PARENT_POLICY APIERROR_BASE + 1009
#define APIERROR_POLICY_UPDATE_NAME_NOT_UNIQUE		APIERROR_BASE + 1010
#define APIERROR_CLIENT_NAME_DUPLICATE				APIERROR_BASE + 1011
#define APIERROR_CLIENT_COMMENT_NOCHANGE			APIERROR_BASE + 1012
#define APIERROR_POLICY_DATA_NO_UPPER				APIERROR_BASE + 1013
#define APIERROR_POLICY_DATA_ONLY_UPPER				APIERROR_BASE + 1014
#define APIERROR_POLICY_NO_DATA						APIERROR_BASE + 1015
#define APIERROR_POLICY_GENERATE					APIERROR_BASE + 1016
#define APIERROR_POLICY_CONVERT						APIERROR_BASE + 1017
#define APIERROR_GROUP_QUERY_DOES_NOT_EXIST			APIERROR_BASE + 1018
#define APIERROR_CLIENT_NEW_NOCHANGE				APIERROR_BASE + 1019
#define APIERROR_CLIENT_ROAMING_NOCHANGE			APIERROR_BASE + 1020
#define APIERROR_GROUP_NAME_OR_DESC_CANNOT_CONTAIN_CHARS APIERROR_BASE + 1022
#define APIERROR_LGTOOLONGNAME						APIERROR_BASE + 1023
#define APIERROR_LGTOOLONGDESC						APIERROR_BASE + 1024
#define APIERROR_PARAMGROUP_EXISTS					APIERROR_BASE + 1025
#define APIERROR_STATICGROUP_EXISTS					APIERROR_BASE + 1026
#define APIERROR_GROUPPARENTNEXST					APIERROR_BASE + 1027
#define APIERROR_INVALID_GROUP_ID					APIERROR_BASE + 1028
#define APIERROR_INVALID_GROUP_RULE_XML				APIERROR_BASE + 1029
#define APIERROR_INVALID_GROUP_TYPE					APIERROR_BASE + 1030
#define APIERROR_INVALID_REPORT_TEMPLATE_ID			APIERROR_BASE + 1031
#define APIERROR_INVALID_REPORT_TEMPLATE_XML		APIERROR_BASE + 1032
#define APIERROR_REPORT_TEMPLATE_NAME_EXISTS		APIERROR_BASE + 1033
#define APIERROR_REPORT_TEMPLATE_NAME_CONFLICT_XML_MISSING APIERROR_BASE + 1034
#define APIERROR_REPORT_TEMPLATE_XML_SERVER_ERROR	APIERROR_BASE + 1035
#define APIERROR_CLEARINFO_NOCHANGE					APIERROR_BASE + 1036
#define APIERROR_INVALID_GROUP_PARENT_TYPE			APIERROR_BASE + 1037
#define APIERROR_INVALID_GROUP_PARENT				APIERROR_BASE + 1038
#define APIERROR_GROUP_PARAM_NOT_APPLICABLE			APIERROR_BASE + 1039
#define APIERROR_GROUP_PARAM_NOT_APPLICABLE_XML		APIERROR_BASE + 1040
#define APIERROR_GROUP_PARAM_MISSING				APIERROR_BASE + 1041
#define	APIERROR_GROUP_PARAM_STICKY_UNCHANGABLE		APIERROR_BASE + 1042
// <-* SECTION 2



// *-> SECTION 3 1500+
#define APIERROR_TASK_INITIALIZATION_FAILED		APIERROR_BASE + 1500
#define APIERROR_TASK_CREATING_FAILED			APIERROR_BASE + 1501
#define APIERROR_UNABLE_TO_READ_FILE			APIERROR_BASE + 1502
#define APIERROR_FILE_IS_EMPTY					APIERROR_BASE + 1503
#define APIERROR_TASK_DATA_WRITING_FAILED		APIERROR_BASE + 1504
#define APIERROR_TASK_COMMIT_FAILED				APIERROR_BASE + 1505
#define APIERROR_ENCODING_CONVERSION_1			APIERROR_BASE + 1506
#define APIERROR_ENCODING_CONVERSION_2			APIERROR_BASE + 1507
#define APIERROR_CAN_SELECT_GROUP_BY_ONLY		APIERROR_BASE + 1508
#define APIERROR_CAN_ORDER_BY_GROUP_BY_ONLY		APIERROR_BASE + 1509
#define APIERROR_INVALID_POLICY_ID		APIERROR_BASE + 1510
#define APIERROR_REPLACEMENT_NEEDED				APIERROR_BASE + 1511
#define APIERROR_REPLACEMENT_NOT_NEEDED			APIERROR_BASE + 1512
#define APIERROR_REPLACEMENT_NOT_INITIALIZED	APIERROR_BASE + 1513
#define APIERROR_DEFAULT_CLIENTS_POLICY_NOT_ALLOWED APIERROR_BASE + 1514
#define APIERROR_NOT_AVAILABLE_NOT_ALLOWED		APIERROR_BASE + 1515
#define APIERROR_POLICY_CAN_NOT_BE_SET_AS_REPLACEMENT APIERROR_BASE + 1516
#define APIERROR_DEFAULT_UPPER_SERVER_POLICY_NOT_ALLOWED APIERROR_BASE + 1517
#define APIERROR_COMPARISON_OPERATOR_NOT_ALLOWED APIERROR_BASE + 1518
#define APIERROR_LIKE_OPERATOR_NOT_ALLOWED APIERROR_BASE + 1519
#define APIERROR_AUTHORIZATION_USING_CURRENT_WINDOWS_SESSION_FAILED APIERROR_BASE + 1520
#define APIERROR_COLUMN_FILTERING_ONLY			APIERROR_BASE + 1521
#define APIERROR_UNSUPPORTED_OPERATOR			APIERROR_BASE + 1522
#define APIERROR_COLUMN_ORDER_BY_MORE_THAN_ONCE	APIERROR_BASE + 1523
#define APIERROR_INVALID_POLICY_RULE_ID			APIERROR_BASE + 1524
#define APIERROR_CANNOT_LOAD_XML_FILE			APIERROR_BASE + 1525
#define APIERROR_XML_PROCESSING_ERROR			APIERROR_BASE + 1526
#define APIERROR_ONLY_LOCAL_RULE_CAN_BE_CHANGED APIERROR_BASE + 1527
#define APIERROR_UNABLE_TO_GET_REPORT_TEMPLATE  APIERROR_BASE + 1528
#define APIERROR_REPORT_GENERATION_INITIALIZING_FAILED APIERROR_BASE + 1529
#define APIERROR_UNABLE_TO_GET_REPORT_GENRATION_PROGRESS APIERROR_BASE + 1530
#define APIERROR_REPORT_GENERATION_FAILED       APIERROR_BASE + 1531
#define APIERROR_REPORT_DOWNLOADING_FAILED      APIERROR_BASE + 1532
// <-* SECTION 3



// *-> SECTION 4 2000+
#define APIERROR_EMPTY_CLIENTLIST						CMDERROR_BASE + 2000
#define APIERROR_CANNOT_ASSIGN_DEFAULT_PARENT_POLICY	CMDERROR_BASE + 2001
#define APIERROR_CANNOT_READ_POLICY_INFO				CMDERROR_BASE + 2002
#define APIERROR_CANNOT_ASSIGN_INACTIVE_POLICY			CMDERROR_BASE + 2003
#define APIERROR_ONLYLOCAL_POLICY_COULD_BE_ASSIGNED		CMDERROR_BASE + 2004
#define APIERROR_OLD_PASSWORD_INCORRECT					CMDERROR_BASE + 2005
#define APIERROR_INTERNAL_ERROR							CMDERROR_BASE + 2006
#define APIERROR_ONLYLOCAL_POLICY_COULD_BE_USED			CMDERROR_BASE + 2007
#define APIERROR_RULE_NAME_EXISTS						CMDERROR_BASE + 2008
#define APIERROR_RULE_NOT_FOUND_IN_XML					CMDERROR_BASE + 2009
#define APIERROR_NO_RULE_CREATED_ON_SERVER				CMDERROR_BASE + 2010
#define APIERROR_CONNECTION_FAILED_INCOMPATIBLE			CMDERROR_BASE + 2011
#define APIERROR_ERROR_FROM_SERVER						CMDERROR_BASE + 2012
// <-* SECTION 4


// ERA command console error codes

#define CMDERROR_BASE 5000

#define CMDERROR_INVALID_PARAMETER				CMDERROR_BASE + 1
#define CMDERROR_INVALID_COMMAND_SYNTAX			CMDERROR_BASE + 2
#define CMDERROR_UNEXPECTED_COMMA				CMDERROR_BASE + 3
#define CMDERROR_UNKNOWN_COMMAND				CMDERROR_BASE + 4

// *-> SECTION 1 1000+

// <-* SECTION 1



// *-> SECTION 2 2000+
#define CMDERROR_UNEXPECTED_INPUT_END			CMDERROR_BASE + 2001
#define CMDERROR_UNEXPECTED_CONN_PARAM			CMDERROR_BASE + 2002
#define CMDERROR_INVALID_PORT					CMDERROR_BASE + 2003
#define CMDERROR_EMPTY_CONN_PARAM				CMDERROR_BASE + 2004
#define CMDERROR_INVALID_CONN_PARAM				CMDERROR_BASE + 2005
#define CMDERROR_CONFLICT_OPTIONS_TWO			CMDERROR_BASE + 2006
#define CMDERROR_FILE_OPEN_ERROR				CMDERROR_BASE + 2007
#define CMDERROR_ENCODING_CONVERSION_1			CMDERROR_BASE + 2008
#define CMDERROR_ENCODING_CONVERSION_2			CMDERROR_BASE + 2009
#define CMDERROR_DELIM_TOO_LONG					CMDERROR_BASE + 2010
#define CMDERROR_NUMBER_EXPECTED_FOR_POLICY_ID	CMDERROR_BASE + 2011
#define CMDERROR_REPORT_UNEXPECTED_ARGUMENT		CMDERROR_BASE + 2012
#define CMDERROR_POLICY_UPDATE_MISSING_PARAMS	CMDERROR_BASE + 2013
#define CMDERROR_CONFLICT_OPTIONS_ASK_ALL		CMDERROR_BASE + 2014
#define CMDERROR_NUMBER_EXPECTED_FOR_GROUP_ID	CMDERROR_BASE + 2015
#define CMDERROR_GROUP_PARAM_NOT_APPLICABLE		CMDERROR_BASE + 2016
#define CMDERROR_GROUP_PARAM_MISSING			CMDERROR_BASE + 2017
#define CMDERROR_NUMBER_EXPECTED_FOR_REPORT_ID	CMDERROR_BASE + 2018
#define CMDERROR_REPORT_TEMPLATE_UPDATE_MISSING_PARAMS CMDERROR_BASE + 2019
#define CMDERROR_UNKNOWN_CLEARINFO_TYPE_SPECIFIED CMDERROR_BASE + 2020
#define CMDERROR_POLICY_RULE_UPDATE_MISSING_PARAMS CMDERROR_BASE + 2021
#define CMDERROR_GROUP_UPDATE_MISSING_PARAMS	CMDERROR_BASE + 2022
// <-* SECTION 2



// *-> SECTION 3 3000+
#define CMDERROR_INVALID_CONDITION_SYNTAX		CMDERROR_BASE + 3000
#define CMDERROR_ASC_OR_DESC_EXPECTED_IN_ORDER	CMDERROR_BASE + 3001
#define CMDERROR_NUMBER_EXPECTED_IN_SKIP		CMDERROR_BASE + 3002
#define CMDERROR_NON_NEGATIVE_NUMBER_EXPECTED_IN_SKIP		CMDERROR_BASE + 3003
#define CMDERROR_NUMBER_EXPECTED_IN_LIMIT		CMDERROR_BASE + 3004
#define CMDERROR_NON_NEGATIVE_NUMBER_EXPECTED_IN_LIMIT		CMDERROR_BASE + 3005
#define CMDERROR_FLAG_EXPECTED					CMDERROR_BASE + 3009
#define CMDERROR_UNSUPPORTED_FLAG				CMDERROR_BASE + 3010
#define CMDERROR_INVALID_BOOL_ARGUMENT			CMDERROR_BASE + 3011
#define CMDERROR_INVALID_FORMATTING				CMDERROR_BASE + 3012
#define CMDERROR_INVALID_ENCODING				CMDERROR_BASE + 3013
#define CMDERROR_INVALID_MODE					CMDERROR_BASE + 3014
#define CMDERROR_UNABLE_TO_READ_FILE			CMDERROR_BASE + 3015
#define CMDERROR_ENCODING_CONVERSION_FAILED		CMDERROR_BASE + 3016
#define CMDERROR_TOO_MANY_LEVELS_IN_FILE_REPLACING		CMDERROR_BASE + 3017
#define CMDERROR_FILE_REPLACING_LOOP_DETECTED	CMDERROR_BASE + 3018
#define CMDERROR_FILE_REPLACING_MISSING_END		CMDERROR_BASE + 3019
#define CMDERROR_INVALID_HEADER_TYPE			CMDERROR_BASE + 3020
#define CMDERROR_NUMBER_EXPECTED_IN_ID_LIST		CMDERROR_BASE + 3021
#define CMDERROR_INVALID_DATETIME				CMDERROR_BASE + 3022
#define CMDERROR_INVALID_BOOL					CMDERROR_BASE + 3023
#define CMDERROR_INVALID_ITEM_ONE_OF_EXPECTED	CMDERROR_BASE + 3025
#define CMDERROR_POSITIVE_NUMBER_EXPECTED		CMDERROR_BASE + 3026
#define CMDERROR_INVALID_FIELD_FORMATTING		CMDERROR_BASE + 3027
#define CMDERROR_LEFT_PARENTHESIS_ONLY_AFTER_IN CMDERROR_BASE + 3028
#define CMDERROR_MISSING_RIGHT_PARENTHESIS		CMDERROR_BASE + 3029
#define CMDERROR_MISSING_COMMA					CMDERROR_BASE + 3030
#define CMDERROR_VALUE_EXPECTED					CMDERROR_BASE + 3031
#define CMDERROR_MISSING_PATH_ARGUMENT			CMDERROR_BASE + 3032
#define CMDERROR_UNKNOWN_CURRENT_SCRIPT_PATH	CMDERROR_BASE + 3033
#define CMDERROR_UNABLE_TO_SET_CURRENT_WORKING_DIRECTORY CMDERROR_BASE + 3034
#define CMDERROR_NO_USERNAME_FOR_DOMAIN			CMDERROR_BASE + 3035
#define CMDERROR_USERNAME_CANNOT_BE_EMPTY		CMDERROR_BASE + 3036
#define CMDERROR_CANNOT_WRITE_TO_FILE			CMDERROR_BASE + 3037
#define CMDERROR_MISSING_END_QUOTE				CMDERROR_BASE + 3038
#define CMDERROR_PATH_IS_A_DIRECTORY			CMDERROR_BASE + 3039
#define CMDERROR_FILE_NOT_WRITABLE				CMDERROR_BASE + 3040
#define CMDERROR_FILE_CANNOT_BE_CREATED			CMDERROR_BASE + 3041
#define CMDERROR_NUMBER_EXPECTED_FOR_POLICY_RULE_ID	CMDERROR_BASE + 3042
#define CMDERROR_NUMBER_EXPECTED_FOR_TEMPLATE_ID CMDERROR_BASE + 3043
// <-* SECTION 3



// *-> SECTION 4 4000+
#define CMDERROR_SCRIPT_TOO_NESTED				CMDERROR_BASE + 4000
#define CMDERROR_SCRIPT_INFINITE_LOOP			CMDERROR_BASE + 4001
#define CMDERROR_HELP_UNKNOWN_COMMAND			CMDERROR_BASE + 4002
#define CMDERROR_COMMAND_UNEXPECTED_ARGUMENT	CMDERROR_BASE + 4003
#define CMDERROR_COMMAND_TOO_MANY_ARGUMENTS		CMDERROR_BASE + 4004
#define CMDERROR_COMMAND_MISSING_ARGUMENT		CMDERROR_BASE + 4005
#define CMDERROR_UNKNOWN_DATA_TYPE_REQUESTED	CMDERROR_BASE + 4006
#define CMDERROR_LIST_NOT_SUPPORTED				CMDERROR_BASE + 4007
#define CMDERROR_INVALID_ARGUMENT_VALUE			CMDERROR_BASE + 4008
#define CMDERROR_PASSWORD_NOT_MATCHING			CMDERROR_BASE + 4009
#define CMDERROR_COMMAND_UNEXPECTED_ARGUMENT2	CMDERROR_BASE + 4010
// <-* SECTION 4
