/**
 * @file Element.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

class Element
{
public:
	Element() { openedList = false; missingOperand = false; }
	virtual ~Element() {}
	virtual std::wstring GetString() const = 0;
	virtual std::vector<const ElementWord *> GetWords() const = 0;

	enum ElementType
	{
		element_word, // =>ElementWord
		element_wordlist, // =>ElementList
	} type;

	bool openedList; // used for autocomplete, detects if it is an opened list ended with comma
	bool missingOperand; // used for autocomplete, detects if it there is unfinished operator: missing operand
};

class ElementWord : public Element
{
public:
	std::wstring GetString() const override;
	virtual std::vector<const ElementWord *> GetWords() const override;

	ElementWord() {type = element_word; }
	tokenArray tokenList;
};

class ElementWordList : public Element
{
public:
	std::wstring GetString() const override;
	virtual std::vector<const ElementWord *> GetWords() const override;

	ElementWordList() {type = element_wordlist; }
	elementwordArray wordList;
};


std::wstring ElementArrayToString(elementArray &elements);

