/**
 * @file EracmdExceptions.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

class EraCMDException
{
public:
	EraCMDException();
	explicit EraCMDException(DWORD ErrorCode, LPCWSTR Param1 = NULL, LPCWSTR Param2 = NULL, LPCWSTR Param3 = NULL, LPCWSTR Param4 = NULL, LPCWSTR Param5 = NULL);
	virtual ~EraCMDException() {}
	DWORD errorCode;
	std::wstring message;

	std::wstring command;
	std::wstring fileName;

	void Print(std::wostream &os) const;

};

class EraCMDException_Pause : public EraCMDException
{
public:
	EraCMDException_Pause();
	EraCMDException_Pause(DWORD ErrorCode, LPCWSTR Param1 = NULL, LPCWSTR Param2 = NULL, LPCWSTR Param3 = NULL, LPCWSTR Param4 = NULL, LPCWSTR Param5 = NULL);
};

class EraCMDException_FromApi : public EraCMDException
{
public:
	EraCMDException_FromApi(const uint32_t resultFromApi);
};

class EraCMDException_FromApi_Pause : public EraCMDException_FromApi
{
public:
	EraCMDException_FromApi_Pause(DWORD resultFromApi);
};

