/**
 * @file FilesReplace.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

class FilesReplace
{

public:
	FilesReplace(const std::wstring &input, const uint32_t maxLevel, const uint32_t currentLevel = 0, std::set<std::wstring> &ignoreFiles = std::set<std::wstring>());

	std::wstring ReplaceAndGetResult();

private:
	void ResetPosition();
	void GoToNextImportantChar();
	void Advance();

	std::wostringstream &GetCurrentOutput();
	void AppendRemainingInput();
	void AppendCurrentChar();

	bool IsAtEnd() const;
	bool IsAtMark() const;
	bool IsAtQuote() const;

	void ProcessFile(const std::wstring &path);

	void ResetStream(std::wostringstream &stream);

	std::wstring TransformFileContent(const std::wstring &txt);

private:
	const std::wstring &input;
	std::set<std::wstring> ignoreFiles;

	uint32_t maxLevel;
	uint32_t currentLevel;

	std::wstring::size_type pos;
	bool inFilePath;
	bool inQuotes;
	std::wstring::size_type currentPartBegin;

	std::wostringstream output;
	std::wostringstream filePath;

	wchar_t mark;
	wchar_t quote;
	std::wstring importantChars;

};

