/**
 * @file Version2.h
 * @author Copyright (c) 2013 ESET, spol. s r. o.
 */

#ifndef __VERSION2_H_INCLUDED
#define __VERSION2_H_INCLUDED

#include "Version.h"

inline DWORD GetVersionMajor(DWORD a, DWORD /*b*/, DWORD /*c*/, DWORD /*d*/) { return a; }
inline DWORD GetVersionMinor(DWORD /*a*/, DWORD b, DWORD /*c*/, DWORD /*d*/) { return b; }
inline DWORD GetVersionBuild(DWORD /*a*/, DWORD /*b*/, DWORD c, DWORD /*d*/) { return c; }

#define PRODUCT_VERSION_MAJOR	GetVersionMajor(_NOD_FILE_VERSION)
#define PRODUCT_VERSION_MINOR	GetVersionMinor(_NOD_FILE_VERSION)
#define PRODUCT_VERSION_BUILD	GetVersionBuild(_NOD_FILE_VERSION)

#define MAKE_VERSION(a, b, c) ((((a) & 0xff) << 24) | (((b) & 0xfff) << 12) | ((c) & 0xfff))

#define RA_CMD_VERSION		MAKE_VERSION(PRODUCT_VERSION_MAJOR, PRODUCT_VERSION_MINOR, PRODUCT_VERSION_BUILD)

#define GET_VERSION_MAJOR(ver) (((ver) & 0xff000000) >> 24)
#define GET_VERSION_MINOR(ver) (((ver) & 0xfff000) >> 12)
#define GET_VERSION_BUILD(ver) ((ver) & 0xfff)

void GetVersionString(DWORD version, LPWSTR buffer, size_t len);

#endif // __VERSION2_H_INCLUDED

