/**
 * @file Command_ClientRename.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_ClientRename.h"

#include <Common/era_api/era_api.h>
#include <Common/era_api/err_codes.h>
#include "../util/stringUtils.h"
#include "../Element.h"
#include "../EracmdExceptions.h"

void Command_ClientRename::Execute(elementArray &elements, OutputHandler &out)
{
	std::wstring clientIdStr(GetArgument(0)->GetString());

	DWORD clientId = 0;
	try
	{
		clientId = WstringToInt(clientIdStr);
	} catch (...)
	{
		throw EraCMDException(CMDERROR_INVALID_PARAMETER, clientIdStr.c_str());
	}

	std::wstring clientName(GetArgument(1)->GetString());

	uint32_t result_clientRename = era_Client_rename(clientId, clientName.c_str());
	if (result_clientRename != 0)
	{
		throw EraCMDException_FromApi(result_clientRename);
	}
}

