/**
 * @file Command_Echo.cpp
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_Echo.h"
#include "../Element.h"


void Command_Echo::Execute(elementArray &elements, OutputHandler &out)
{
	std::shared_ptr<Element> el = GetArgument(0);

	std::wstring result;
	
	if (el != NULL)
	{
		if (el->type == Element::element_wordlist)
		{
			std::shared_ptr<ElementWordList> elW = std::static_pointer_cast<ElementWordList>(el);
			for (size_t i = 0; i < elW->wordList.size(); ++i)
				result += elW->wordList[i]->GetString();
		}
		else result = GetArgumentAsString(0);
	}

	result+=L"\n";
	out.PrintRaw(result);
}

