/**
 * @file Command_GroupAssign.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_GroupAssign.h"

#include <Common/era_api/era_api.h>
#include <Common/era_api/err_codes.h>
#include <Common/scope_exit.h>
#include "../util/apiUtils.h"
#include "../util/stringUtils.h"
#include "../Element.h"
#include "../EracmdExceptions.h"

void Command_GroupAssign::Execute(elementArray &elements, OutputHandler &out)
{
	int groupId;
	const std::wstring elementStr = GetArgument(0)->GetString();
	try
	{
		groupId = WstringToUint(elementStr);
	}
	catch (...)
	{
		throw EraCMDException(CMDERROR_NUMBER_EXPECTED_FOR_GROUP_ID, elementStr.c_str());
	}

	Era_ClientList *clients = ElementToClientList(GetArgument(1));
	scope_exit se_clients(std::bind(era_ClientList_delete, clients));

	uint32_t result = era_Group_assign(groupId, clients);
	if (result != 0)
		throw EraCMDException_FromApi(result);
}
