/**
 * @file Command_GroupDelete.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */


#include "set_nod.h"
#include "Command_GroupDelete.h"

#include <Common/era_api/err_codes.h>
#include "../util/stringUtils.h"
#include "../Element.h"
#include "../EracmdExceptions.h"

void Command_GroupDelete::Execute(elementArray &elements, OutputHandler &out)
{
	uint32_t deletedGroupId = 0;
	{
		const std::wstring elementStr = GetArgument(0)->GetString();

		try
		{
			deletedGroupId = ::WstringToUint(elementStr);
		}
		catch (...)
		{
			throw EraCMDException(CMDERROR_NUMBER_EXPECTED_FOR_GROUP_ID, elementStr.c_str());
		}
	}

	uint32_t result_groupDelete = era_Group_delete(deletedGroupId);
	if (result_groupDelete != 0)
	{
		throw EraCMDException_FromApi(result_groupDelete);
	}
}

