/**
 * @file Command_GroupImport.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_GroupImport.h"

#include <Common/era_api/err_codes.h>
#include "../util/stringUtils.h"
#include "../Element.h"
#include "../EracmdExceptions.h"

void Command_GroupImport::Execute(elementArray &elements, OutputHandler &out)
{
	std::wstring groupType = GetArgument(0)->GetString();
	bool parametric = (_wcsicmp(groupType.c_str(), L"parametric") == 0);

	std::wstring parentIdStr = GetArgument(1)->GetString();
	uint32_t parentId = 0;
	if (parentIdStr != L"*")
	{
		try
		{
			parentId = ::WstringToUint(parentIdStr);
			if (parentId == 0) throw 0;
		}
		catch (...)
		{
			throw EraCMDException(CMDERROR_NUMBER_EXPECTED_FOR_GROUP_ID, parentIdStr.c_str());
		}
	}

	std::wstring file = GetArgument(2)->GetString();

	std::wstring relations;
	if (std::shared_ptr<Element> arg = GetArgument(3))
		relations = arg->GetString();

	uint32_t result = era_Group_import(parentId, file.c_str(), parametric, _wcsicmp(relations.c_str(), L"TRUE") == 0);
	if (result != 0)
		throw EraCMDException_FromApi(result);
}

