/**
 * @file Command_Help.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

#include "../util/stringUtils.h"
#include "../Command.h"
#include "../ScriptInterpreter.h"

class Command_Help : public Command
{
public:
	Command_Help(CommandList &commandList);
	virtual void Execute(elementArray &elements, OutputHandler &out) override;

	GENERATE_HELP_ID_METHODS(HELP)

protected:
	CommandList &commandList;
	std::wstring GetCommandSyntaxHelp(std::shared_ptr<Command> command, std::wstring &commandString, SHORT screenX);
	std::wstring BuildParamList(ItemAndDescriptionFormatter &frmt, const std::wstring &paramLine);
	std::wstring possibleValues;
	std::wstring defaultValue;
};

