/**
 * @file Command_PolicyCreate.cpp
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_PolicyCreate.h"

#include <Common/scope_exit.h>
#include "../util/stringUtils.h"
#include "../EracmdExceptions.h"


void Command_PolicyCreate::Execute(elementArray &elements, OutputHandler &out)
{
	Era_PolicyParams *params = era_PolicyParams_new();
	scope_exit se_query(std::bind(era_PolicyParams_delete, params));

	FillPolicyParams(0, false, *params);

	uint32_t newPolicyId = -1;
	uint32_t result_policyCreate = era_Policy_create(&newPolicyId, params);
	if (result_policyCreate != 0)
	{
		throw EraCMDException_FromApi(result_policyCreate);
	}

	StringVector header(1);
	header[0] = L"policy_id";
	StringVector prettyHeader(1);
	prettyHeader[0] = LoadStringFromResource(IDS_POLICY_ID);
	std::vector<StringVector> rows;
	StringVector data(1);
	data[0] = std::to_wstring((long long)newPolicyId);
	rows.push_back(data);
	TableReader_Const reader(header, prettyHeader, rows);
	out.Print(reader);
}
