/**
 * @file Command_ReportExport.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_ReportExport.h"

#include <Common/era_api/err_codes.h>
#include "../util/stringUtils.h"
#include "../Element.h"
#include "../EracmdExceptions.h"

void Command_ReportExport::Execute(elementArray &elements, OutputHandler &out)
{
	std::wstring reportType = GetArgument(0)->GetString();
	bool dashboard = (_wcsicmp(reportType.c_str(), L"dashboard") == 0);

	std::vector<uint32_t> idList;

	if (GetArgument(1)->GetString() != L"*")
	{
		std::vector<const ElementWord*> items = GetArgument(1)->GetWords();
		for (size_t i = 0; i < items.size(); i++)
		{
			std::wstring id = items[i]->GetString();
			try
			{
				idList.push_back(WstringToUint(id));
			} catch (...)
			{
				throw EraCMDException(CMDERROR_NUMBER_EXPECTED_IN_ID_LIST, id.c_str());
			}
		}
	}

	std::wstring file = GetArgument(2)->GetString();

	uint32_t result = era_ReportTemplate_export(idList.empty() ? NULL : idList.data(), (uint32_t) idList.size(), file.c_str(), dashboard);
	if (result != 0)
		throw EraCMDException_FromApi(result);
}

