/**
 * @file Command_RunNow.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_RunNow.h"

#include <Common/era_api/era_api.h>
#include <Common/era_api/err_codes.h>
#include "../Element.h"
#include "../EracmdExceptions.h"

void Command_RunNow::Execute(elementArray &elements, OutputHandler &out)
{
	uint32_t actions = 0;

	std::shared_ptr<Element> element = GetArgument(0);

	std::vector<const ElementWord *> words = element->GetWords();
	for (std::vector<const ElementWord *>::const_iterator it = words.begin(); it != words.end(); ++it)
	{
		if (::_wcsicmp((*it)->GetString().c_str(), L"cleanup") == 0) actions |= ERA_RUN_NOW__CLEANUP;
		if (::_wcsicmp((*it)->GetString().c_str(), L"compact") == 0) actions |= ERA_RUN_NOW__COMPACT;
		if (::_wcsicmp((*it)->GetString().c_str(), L"replicate") == 0) actions |= ERA_RUN_NOW__REPLICATE;
		if (::_wcsicmp((*it)->GetString().c_str(), L"replicate_with_mark_all_clients") == 0) actions |= ERA_RUN_NOW__REPLICATE_WITH_MARK_ALL_CLIENTS;
		if (::_wcsicmp((*it)->GetString().c_str(), L"update") == 0) actions |= ERA_RUN_NOW__UPDATE;
		if (::_wcsicmp((*it)->GetString().c_str(), L"update_with_clear_cache") == 0) actions |= ERA_RUN_NOW__UPDATE_WITH_CLEAR_CACHE;
		if (::_wcsicmp((*it)->GetString().c_str(), L"apply_policy_rules") == 0) actions |= ERA_RUN_NOW__APPLY_POLICY_RULES;
		if (::_wcsicmp((*it)->GetString().c_str(), L"synchronize_parametric_groups") == 0) actions |= ERA_RUN_NOW__SYNCHRONIZE_PARAMETRIC_GROUPS;
	}

	uint32_t rc = era_RunNow(actions);
	if (rc != ERAERROR_SUCCESS) throw EraCMDException_FromApi(rc);
}

