/**
 * @file Command_ServerConfig.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

#include "../Command.h"

enum ServerConfigAction
{
	SHOW_SERVER_CFG,
	GET_SERVER_CFG,
	PUT_SERVER_CFG,
	SET_SERVER_CFG,
	SETPWD_SERVER_CFG,
	LIST_SERVER_CFG,
};

class Command_ServerConfig : public Command
{
public:

	Command_ServerConfig();

	Command_ServerConfig(ServerConfigAction GetMode, ScriptInterpreter *scriptInterpreter = NULL);

	virtual void Execute(elementArray &elements, OutputHandler &out) override;

	virtual unsigned int GetHelpFullId() override;

	virtual unsigned int GetHelpShortId() override;

	virtual unsigned int GetHelpExampleId() override;

private:

	ScriptInterpreter *scriptInterpreter;

	ServerConfigAction Action;
};
