/**
 * @file Command_Set.h
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#pragma once

#include <string>
#include "../Command.h"

#include "../flags/FlagsRegistry.h"

struct CommandFlags;

class Command_Set : public Command
{
public:
	Command_Set(CommandFlags &currentFlags);
	virtual void Execute(elementArray &elements, OutputHandler &out) override;

	GENERATE_HELP_ID_METHODS(SET)

private:
	void PrintFlagsState(const FlagsRegistry::Flags &flags, OutputHandler &out);
	void SaveFlagsState(const std::wstring &filePath);

private:
	CommandFlags &currentFlags;

};

