/**
 * @file Command_TaskScan.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

#include "Command_Task.h"

struct Era_ScanParams_Windows;
struct Era_ScanParams_Linux3;
struct Era_ScanParams_Linux;
struct Era_ScanParams_Mobile;
enum Era_ScanProfile;

class Command_TaskScan : public Command_Task
{
public:
	virtual void Execute(elementArray &elements, OutputHandler &out) override;

	GENERATE_HELP_ID_METHODS(TASKSCAN)

private:
	void FillParams_Windows(const int argNumOffset, Era_ScanParams_Windows &params);
	void FillParams_Linux3(const int argNumOffset, Era_ScanParams_Linux3 &params);
	void FillParams_Linux(const int argNumOffset, Era_ScanParams_Linux &params);
	void FillParams_Mobile(const int argNumOffset, Era_ScanParams_Mobile &params);

	static bool KeywordToScanProfile(const std::wstring elementStr, Era_ScanProfile &profile);

};
