/**
 * @file ConsoleColors.h
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#pragma once

#include "Color.h"

class ConsoleColors
{

public:

	#pragma warning (push)
	#pragma warning (disable : 4355)

	ConsoleColors()
	:
		DEFAULT(*this),
		BLACK(*this),
		BLUE(*this),
		GREEN(*this),
		AQUA(*this),
		RED(*this),
		PURPLE(*this),
		YELLOW(*this),
		LIGHT_GRAY(*this),
		GRAY(*this),
		LIGHT_BLUE(*this),
		LIGHT_GREEN(*this),
		LIGHT_AQUA(*this),
		LIGHT_RED(*this),
		LIGHT_PURPLE(*this),
		LIGHT_YELLOW(*this),
		WHITE(*this),
		DEFAULT_LIGHTBACK(*this),
		GREEN_LIGHTBACK(*this)
	{
	}

	#pragma warning (pop)

	virtual ~ConsoleColors() {}

public:
	virtual void SetTextColor(std::wostream &os, const Color &color) = 0;

public:
	Color DEFAULT;
	Color DEFAULT_LIGHTBACK;

	Color BLACK;
	Color BLUE;
	Color GREEN;
	Color GREEN_LIGHTBACK;
	Color AQUA;
	Color RED;
	Color PURPLE;
	Color YELLOW;
	Color LIGHT_GRAY;
	Color GRAY;
	Color LIGHT_BLUE;
	Color LIGHT_GREEN;
	Color LIGHT_AQUA;
	Color LIGHT_RED;
	Color LIGHT_PURPLE;
	Color LIGHT_YELLOW;
	Color WHITE;

};

