/**
 * @file CommandFlagsStack.cpp
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "CommandFlagsStack.h"

#include "../console_colors/ConsoleColors_Win.h"

extern ConsoleColors_Win gConsoleColors;

CommandFlagsStack::CommandFlagsStack()
{
	stack.push(CommandFlags());
}

void CommandFlagsStack::Push()
{
	stack.push(stack.top());
}

void CommandFlagsStack::Pop()
{
	if (stack.size() <= 1)
	{
		throw std::exception("incorrect CommandFlagsStack usage - pop called more times than push");
	}

	stack.pop();
	gConsoleColors.SetColoring(CurrentFlags().color);
}

CommandFlags &CommandFlagsStack::CurrentFlags()
{
	return stack.top();
}

