/**
 * @file FlagValuesConversions.h
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#pragma once

#include "CommandFlags.h"

namespace FlagValuesConversions {

	std::wstring FromBool(const bool value);
	bool ToBool(const std::wstring &str);

	std::wstring FromBoolWithCustomNames(const bool value, const std::wstring &trueValue, const std::wstring &falseValue);
	bool ToBoolWithCustomNames(const std::wstring &str, const std::wstring &trueValue, const std::wstring &falseValue);

	std::wstring FromOutputFormatting(const CommandFlags::OuputFormatting value);
	CommandFlags::OuputFormatting ToOutputFormatting(const std::wstring &str);

	std::wstring FromEncoding(const CommandFlags::Encoding value);
	CommandFlags::Encoding ToEncoding(const std::wstring &str);

	std::wstring FromOutputMode(const CommandFlags::OutputMode value);
	CommandFlags::OutputMode ToOutputMode(const std::wstring &str);

	std::wstring FromHeaderType(const CommandFlags::HeaderType value);
	CommandFlags::HeaderType ToHeaderType(const std::wstring &str);

	std::wstring FromFieldFormatting(const CommandFlags::FieldFormatting value);
	CommandFlags::FieldFormatting ToFieldFormatting(const std::wstring &str);

	std::wstring FromDelimiter(const wchar_t value);
	wchar_t ToDelimiter(const std::wstring &str);

	std::wstring FromString(const std::wstring &value);
	std::wstring ToString(const std::wstring &str);
	std::wstring ToWritablePath(const std::wstring &str);

}

