/**
 * @file OutputFormatter_CSV.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

#include "../console_colors/ConsoleColors_Win.h"
#include "OutputFormatter.h"

class OutputFormatter_CSV : public OutputFormatter
{

public:
	OutputFormatter_CSV(const WCHAR fieldDelimiter, const WCHAR textDelimiter, ConsoleColors_Win &consoleColors);

public:

	virtual void Print(TableReader &reader, std::wostream &out, const CommandFlags::HeaderType headerType, DWORD screenWidth, const TextWidth &textWidth) override;

private:

	void PrintRow(const StringVector &row, std::wostream &out);

private:

	WCHAR fieldDelimiter;
	WCHAR textDelimiter;

	ConsoleColors_Win &consoleColors;
};

